
/*****************************************************************************
 * @copyright       2024-2024, . POWER SUPPLY CO., LTD. 
 * @file            daemon.c
 * @brief           进程守护
 * @author          Gary
 * @date            2024/09/20
 * @remark          
 *****************************************************************************/
#ifndef DAEMON_H
#define DAEMON_H

#define DAEMON_LOCK_FNAME "/tmp/company-ems.pid"


/*****************************************************************************
 * @brief           守护进程启动函数    
 * @return          
 *****************************************************************************/
void daemonize();

/*****************************************************************************
 * @brief           检查守护进程是否已运行   
 * @return          0-没有运行，进行上锁；1-正在运行
 *****************************************************************************/
int checkDaemonRunning();

/*****************************************************************************
 * @brief           停止守护进程    
 * @return          0-成功；1-失败
 *****************************************************************************/
int stop_daemon();

#endif