/*****************************************************************************
 * @copyright       2024-202, . POWER SUPPLY CO., LTD. 
 * @file            logic_debug.c
 * @brief           xxxx
 * @author          Gary
 * @date            2024/09/27
 * @remark          初修订
 *****************************************************************************/
#include "logic_comm.h"

/*****************************************************************************
 * @brief       获取调试模式运行参数接口 (暂时没有额外功能)
 * @return      0 更新成功 -1 失败 1 无更新
 *****************************************************************************/
int logic_debugParamUpdate()
{
    static debug_params_t *debug_params = &stlogic.para_delivery.task_params.debug;
    if (NULL == debug_params)
    {
        return 1;
    }
    // 配置变化标志
    debug_algorithm_t p_debugAlgo = {0, 0, 0};
    if (1 == kit_get_debug_algorithm(&p_debugAlgo))
    {
        return 1;
    }
    debug_params->activePower = p_debugAlgo.activePower;
    debug_params->reactivePower = p_debugAlgo.reactivePower;
    debug_params->pcsSwitch = p_debugAlgo.pcsSwitch;
    debug_params->protectSwitch = p_debugAlgo.protectSwitch;
    //debug_params->protectSwitch =1;

    if(debug_params->pcsSwitch)
    {
        stlogic.para_delivery.task_params.protect.power = debug_params->activePower;
        stlogic.para_delivery.task_params.protect.rePower = debug_params->reactivePower;
    }
    else
    {
        debug_params->activePower = 0;
        debug_params->reactivePower = 0;
    }
    return 0;
}

/*****************************************************************************
 * @brief       获取调试模式运行参数接口 (暂时没有额外功能)
 * @return      -1 失败 0 成功
 *****************************************************************************/
int logicFun_debug()
{
    debug_params_t *debug_params = &stlogic.para_delivery.task_params.debug;
    if(NULL == debug_params)
    {
        return -1;
    }
    stlogic.para_delivery.task_params.protect.power = debug_params->activePower;
    return 0;
}